#include <math.h>
#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "dstrus.h"
#include "funs.h"
#define  NO	"n\0"
#define  YES	"y\0"
#define CALLOC(n,x)		((x *)calloc((unsigned)n,(unsigned)sizeof(x)+1))
#define CON			2.302585093
#define H(y)			(exp(CON*(y+9)))
#define IH(y)			(log10(y))
#define GCVT(x)			gcvt((double)x,6,buf)

et e;
mt m;
vt v;
ot o;
/*---------------------------------*/
void selct(char *);
void mvcalloc(int);
void mvfree();
void kin(void (*)(),char *);
void comp3();
void comprt();
void compnsb();
void comp1();
void z_frm(void);
void z_frmnsb(void);
void marq(void);
double psizero(double *,double *,double);
double psizerom(double *,double *,double);
double Kd,ss,lambda=0.1;
/*---------------------------------*/
int main(int argc,char *argv[])
 {
  char gs[2],ft[13],f[9];

  printf("This is the nonlinear least-squares 3-parameter program\n");
  printf("for Rt, Ki, and Nonspecific binding (competition)\n");
  printf("using the Marquardt method\n\n");
  printf("\n\tWhat value of Kd will you use?");
  scanf("%le",&Kd);
  if (argc==2)
   {
    puts("\n\n\n\n\n\t\t\tpress a key");
	 getchar();
    strcpy(ft,argv[1]);
    strcat(ft,".lex");
    printf("\n\tIs data to be input from the keyboard (y or n)?");
    fflush(stdout);
    scanf("%s",gs);
    if ((strcmp(gs,NO))==0) filnpt1(ft,&e);
    else kbdnpt1(ft,&e);
   }
  else
   {
    printf("\tData file name (w/o extension)=");
    scanf("%s",f);
    strcpy(ft,f);
    strcat(ft,".lex");
    printf("\n\tIs data to be input from the keyboard (y or n)?");
    fflush(stdout);
    scanf("%s",gs);
    if ((strcmp(gs,NO))==0) filnpt1(ft,&e);
    else kbdnpt1(ft,&e);
   }
    selct(f);
    free(e.y);free(e.x);
    exit(1);
 }
/*----------------------------------------------------*/
void selct(char *f)
 {
  int selec,i;

  o.otptnm[0]=CALLOC(6,char);
  o.otptnm[1]=CALLOC(6,char);
  o.otptnm[2]=CALLOC(6,char);
  strcpy(o.otptnm[0],"Ki=");
  strcpy(o.otptnm[1],"Rt=");
  strcpy(o.otptnm[2],"nsb=");

  for(i=0;i<e.n;i++){
    e.x[i]=H(e.x[i]);
    e.y[i]*=e.cf;
	}
  e.xm=H(e.xm);e.xl=H(e.xl);e.ym*=e.cf;e.yl*=e.cf;e.T*=e.cf;

  printf("File=%s\n",f);
  puts("Choose which subroutine to use for the analysis");
  puts("1=comp3, 2=comprt, 3=compnsb, or 4=comp1");
  scanf("%d",&selec);
  switch(selec){
	 case 1:
		v.p=3;
		mvcalloc(3);
      kin(comp3,f);
      mvfree();
     break;
    case 2:
      v.p=2;
      mvcalloc(2);
      kin(comprt,f);
      mvfree();
     break;
    case 3:
      v.p=2;
      mvcalloc(2);
      kin(compnsb,f);
      mvfree();
     break;
    case 4:
      v.p=1;
      mvcalloc(1);
      kin(comp1,f);
      mvfree();
   }
 return;
 }
/*----------------------------------------------------*/
void mvcalloc(int n)
		/* n=v.p */
 {
  m.z=CALLOC(e.n*n,double);
  m.zt=CALLOC(e.n*n,double);
  m.zz=CALLOC(n*n,double);
  m.pa=CALLOC(3,double);
  m.dpa=CALLOC(n,double);

 return;
 }
/*---------------------------------------------------*/
void mvfree()
 {
  free(m.dpa);free(m.pa);free(m.zz);free(m.zzi);free(m.zt);free(m.z);
  return;
 }
/*---------------------------------------------------*/
void kin(void (*f)(),char *fil)
 {
  int i,j=0;
  double a,rat;
  FILE *fp1;
  char buf[15],ft[12],sr[15];

  extern double vect_ip(),absum(),min(),power(),v_sqr(),ycalc();
  extern void mat_sqr(),mat_transp(),vect_mat_mpy(),vect_inc(),itno(),fwri();
  extern void calpplt(),explt(),axlabel(),mat_vect_mpy(),mat_inv(),otput();

  (*f)();
  v.yc=CALLOC(e.n,double);
  v.dy=CALLOC(e.n,double);
  v.gx=CALLOC(e.n,double);
  v.jy=CALLOC(e.n,double);
  v.zy=CALLOC(v.p,double);

	  for(i=0;i<e.n;i++){
		 v.gx[i]=e.x[i];
		 v.jy[i]=v.yc[i]=ycalc(e.x[i],e.y[i],m.pa,e.T);
		 v.dy[i]=e.y[i]-v.yc[i];
		}
	ss=v_sqr(v.dy,e.n);
  do{
	  if(strcmp(f,"comp2nsb\0")==0) z_frmnsb();
	  else z_frm();				/* Form z and dy */

	  mat_sqr(m.z,v.p,e.n,m.zz);			/* Form the Z*Z-Matrix  */
	  mat_transp(m.z,m.zt,v.p,e.n);
	  vect_mat_mpy(m.zt,e.n,v.p,v.dy,v.zy);	/* Form the Zt*Y Vector  */

	  marq();				/* Find the best correction */

 /* Plot the calculated points obtained using the adjusted Parameters */
 /* And calculate the new yc and dy vectors */

		for(i=0;i<e.n;i++){
	v.jy[i]=v.yc[i]=ycalc(e.x[i],e.y[i],m.pa,e.T);
	v.dy[i]=e.y[i]-v.yc[i];
       }
	j+=1;
	}while(((rat=absum(m.dpa,v.p)/absum(m.pa,v.p))>1e-3)  && (j<300));

	/* Now, without corrections */


	  z_frm();					/* Form Z */
	  mat_sqr(m.z,v.p,e.n,m.zz);			/* Form the Z*Z-Matrix  */
	  mat_transp(m.z,m.zt,v.p,e.n);

	  for(i=0;i<e.n;i++){
		 v.yc[i]=ycalc(e.x[i],e.y[i],m.pa,e.T);
		 v.dy[i]=e.y[i]-v.yc[i];
		}

	  m.zzi=CALLOC(v.p*v.p,double);
	  vect_mat_mpy(m.zt,e.n,v.p,v.dy,v.zy);	/* Form the Zt*Y Vector */
	  mat_inv(m.zz,v.p,m.zzi);			/* Invert ZZ */
	  mat_vect_mpy(m.zzi,v.p,v.p,v.zy,m.dpa);	/* Get the increments */
	  vect_inc(m.pa,m.dpa,v.p);			/* Final Correction */
	  free(v.jy);
	  free(v.gx);


  v.gx=CALLOC(150,double);
  v.jy=CALLOC(150,double);
  v.gx[0]=H(-13.);
  v.jy[0]=ycalc(v.gx[0],v.yc[0],m.pa,e.T);
	  for(i=-130;i<-40;i++){
		 v.gx[i+131]=H(((double)(i+1))/10);
		 v.jy[i+131]=ycalc(v.gx[i+131],v.jy[i+130],m.pa,e.T);
		}

		 strcpy(ft,fil);
		 strcat(ft,".clc");
		 fp1=fopen(ft,"w");
		 for(j=0;j<90;j++){
	 strcpy(sr,GCVT(IH(v.gx[j])));
	 fwri(sr,fp1);
	 fwrite(" ",1,1,fp1);
	 strcpy(sr,GCVT(v.jy[j]/e.cf));
	 fwri(sr,fp1);
	 fwrite("\n",1,1,fp1);
	}
		 fclose(fp1);


		 strcpy(ft,fil);
		 strcat(ft,".e");
		 fp1=fopen(ft,"w");
		 for(j=0;j<e.n;j++){
	 strcpy(sr,GCVT(IH(e.x[j])));
	 fwri(sr,fp1);
	 fwrite(" ",1,1,fp1);
	 strcpy(sr,GCVT(e.y[j]/e.cf));
	 fwri(sr,fp1);
	 fwrite("\n",1,1,fp1);
	}
		 fclose(fp1);


		 strcpy(ft,fil);
		 strcat(ft,".exp");
		 fp1=fopen(ft,"w");
		 for(j=0;j<e.n;j++){
	 strcpy(sr,GCVT(IH(e.x[j])-9.));
	 fwri(sr,fp1);
	 fwrite("\t",1,1,fp1);
	 strcpy(sr,GCVT(e.y[j]/e.cf));
	 fwri(sr,fp1);
	 fwrite("\r",1,1,fp1);
	}
		 fclose(fp1);

	  free(v.jy);
	  free(v.gx);
	 otput(fil,ss,&e,&v,&o,&m);
  free(v.dy);free(v.yc);
  free(o.otptnm[0]);free(o.otptnm[1]);free(o.otptnm[2]);
 return;
 }
/*---------------------------*/
void comp3()
 {
  puts("Three Parameter Analysis (for Ki, Rt, and nsb)\n");
  puts("\nEstimate of Ki=?");
  scanf("%lf",&m.pa[0]);
  puts("\nEstimate of Rt=?");
  scanf("%lf",&m.pa[1]);
  puts("\nEstimate of nsb=?");
  scanf("%lf",&m.pa[2]);
 return;
 }
/*---------------------------*/
void comprt()
 {
  puts("Two Parameter Analysis (for Ki and Rt)\n");
  puts("\nEstimate of Ki=?");
  scanf("%lf",&m.pa[0]);
  puts("\nEstimate of Rt=?");
  scanf("%lf",&m.pa[1]);
  puts("\nnsb=?");
  scanf("%lf",&m.pa[2]);
 return;
 }
/*---------------------------*/
void compnsb()
 {
  puts("Two Parameter Analysis (for Ki and nsb)\n");
  puts("\nEstimate of Ki=?");
  scanf("%lf",&m.pa[0]);
  puts("\nRt=?");
  scanf("%lf",&m.pa[1]);
  puts("\nEstimate of nsb=?");
  scanf("%lf",&m.pa[2]);
 return;
 }
/*---------------------------*/
void comp1()
 {
  puts("One Parameter Analysis (for Ki)\n");
  puts("\nEstimate of Ki=?");
  scanf("%lf",&m.pa[0]);
  puts("\nRt=?");
  scanf("%lf",&m.pa[1]);
  puts("\nnsb=?");
  scanf("%lf",&m.pa[2]);
 return;
 }
/*---------------------------------------------------*/
void z_frm(void)
 {
  int i,k;
  double y;
  extern double v_sqr(),power();

	for(i=0;i<e.n;i++){
	  v.dy[i]=e.y[i]-v.yc[i];
	  for(k=0;k<v.p;k++){
		 switch(k){
	 case 0:
	  m.z[i*v.p+k]=-FA(e.x[i],e.y[i],m.pa[0],m.pa[2],e.T,Kd)/DFDY(e.x[i],e.y[i],m.pa[0],m.pa[2],e.T,Kd);
	  break;
	 case 1:
	  m.z[i*v.p+k]=-FB()/DFDY(e.x[i],e.y[i],m.pa[0],m.pa[2],e.T,Kd);
	  break;
	 case 2:
	  m.z[i*v.p+k]=-FC(e.x[i],e.y[i],m.pa[0],m.pa[2],e.T,Kd)/DFDY(e.x[i],e.y[i],m.pa[0],m.pa[2],e.T,Kd);
	  break;

	}
		}
	 }
 }
/*---------------------------------------------------*/
void z_frmnsb(void)
 {
  int i,k;
  double y;
  extern double v_sqr(),power();

	for(i=0;i<e.n;i++){
	  v.dy[i]=e.y[i]-v.yc[i];
	  for(k=0;k<v.p;k++){
		 switch(k){
	 case 0:
	  m.z[i*v.p+k]=-FA(e.x[i],e.y[i],m.pa[0],m.pa[2],e.T,Kd)/DFDY(e.x[i],e.y[i],m.pa[0],m.pa[2],e.T,Kd);
	  break;
	 case 1:
	  m.z[i*v.p+k]=-FC(e.x[i],e.y[i],m.pa[0],m.pa[2],e.T,Kd)/DFDY(e.x[i],e.y[i],m.pa[0],m.pa[2],e.T,Kd);
	  break;

	}
		}
	 }
 }
/*---------------------------------------------------------*/
void marq()	/* The Marquardt method */
 {
  double ss1,ss2;
  double lmbda=lambda;
  double nuinc=2.5,nudec=2.5,ro=0.9;
  double *cdpa1,*cpa1,*cdpa2,*cpa2,cozth;
  extern void vect_inc(),vect_sub(),mat_cpy(),vec_cpy(),vec_init();
  extern double vect_ip(),v_sqr(),max();

  cdpa1=CALLOC(v.p,double);
  cpa1=CALLOC(3,double);
  cdpa2=CALLOC(v.p,double);
  cpa2=CALLOC(3,double);
  vec_cpy(m.pa,cpa1,3);
  vec_cpy(m.pa,cpa2,3);
  vec_init(cdpa1,v.p);
  vec_init(cdpa2,v.p);
	ss1=psizerom(cpa1,cdpa1,lmbda);
	ss2=psizerom(cpa2,cdpa2,lmbda/nudec);

  if(ss2 <=ss){			/* This determines that the */
    lambda=max(lmbda/nudec,1e-7);		/* direction approaches that of */
	 vec_cpy(cpa2,m.pa,v.p);
	 vec_cpy(cdpa2,m.dpa,v.p);
	 ss=ss2;   				/* having succeeded in improving the */
	 free(cpa2);free(cdpa2);free(cpa1);free(cdpa1);
	}					/* sum of squares */
  else if (ss2 > ss && ss1 <= ss){
	 lambda=lmbda;
	 vec_cpy(cpa1,m.pa,v.p);
	 vec_cpy(cdpa1,m.dpa,v.p);
	 ss=ss1;
	 free(cpa2);free(cdpa2);free(cpa1);free(cdpa1);
  }
  else if (ss2 > ss && ss1 > ss){	/* INCREASE LAMBDA */
	 do{
	 cozth=vect_ip(cdpa1,v.zy,v.p)/(sqrt(v_sqr(cdpa1,v.p)*v_sqr(v.zy,v.p)));
	 if(cozth < 0.7071 && lmbda < 10.) {	/* That is, the angle is acceptable */
		lmbda*=nuinc;
		ss1=psizerom(cpa1,cdpa1,lmbda);
	  }
	 else{       			/* Reset lambda and Interpolate */
		lmbda=5.;
		do{
			ss1=psizero(cpa1,cdpa1,ro);
			ro-=0.05;
		 }while (ss1>ss && ro > 0);
	  }
	  }while (ss1>ss);
	 lambda=lmbda;
	 vec_cpy(cpa1,m.pa,v.p);
	 vec_cpy(cdpa1,m.dpa,v.p);		/* based on the marq adjustment not */
	 ss=ss1;
	 free(cpa2);free(cdpa2);free(cpa1);free(cdpa1);
	}
 return;
 }
/*---------------------------------*/
double psizero(double *cpa,double *cdpa,double ro)
	/* Only varies step size */
 {
  double s=0.0,*y;
  extern void vect_inc(),vec_cpy(),v_mpy_c();
  extern double ycalc();
  int i;

  y=CALLOC(e.n,double);
  vec_cpy(m.pa,cpa,3);		/* Copy the parameters -> cpa*/
  vec_cpy(m.dpa,cdpa,v.p);	/* Copy the corrections -> cdpa */
  v_mpy_c(cdpa,v.p,ro);		/* Multiply the cdpa by ro */
  vect_inc(cpa,cdpa,v.p);	/* Increment cpa by cdpa*ro */
  for(i=0;i<e.n;i++){
	 y[i]=ycalc(e.x[i],e.y[i],cpa,e.T);
	 s+=(e.y[i]-y[i])*(e.y[i]-y[i]);
	}
  free(y);
 return s;
 }
/*---------------------------------*/
double psizerom(double *cpa,double *cdpa,double af)
					/* Varies the zz matrix */
 {
  double *zzm,*zzmi,*y,s=0.0;
  int i;
  extern void vect_inc(),mat_cpy(),vec_cpy(),mat_inv(),mat_vect_mpy();
  extern double ycalc();

  y=CALLOC(e.n,double);
  zzm=CALLOC(v.p*v.p,double);
  zzmi=CALLOC(v.p*v.p,double);
  mat_cpy(m.zz,zzm,v.p,v.p);
  vec_cpy(m.pa,cpa,3);	/* Copy the parameters -> cpa*/
  for(i=0;i<v.p;i++) zzm[i*v.p+i]+=af*zzm[i*v.p+i];
  mat_inv(zzm,v.p,zzmi);
  mat_vect_mpy(zzmi,v.p,v.p,v.zy,cdpa);
  vect_inc(cpa,cdpa,v.p);
  for(i=0;i<e.n;i++){
	 y[i]=ycalc(e.x[i],e.y[i],cpa,e.T);
	 s+=(e.y[i]-y[i])*(e.y[i]-y[i]);
	}
 free(zzmi);free(zzm);free(y);
 return s;
 }

