#include "dstrus.h"
#include "funs.h"
#include <math.h>
#define CALLOC(n,x)	     ((x *)calloc((unsigned)n,(unsigned)sizeof(x)))
#define CON		     2.302585093

/*---------------------------------*/
double max(double,double);
double min(double,double);
double ycalc(double,double,double *,double);
void swap(double *,double *);
extern double power();
/*---------------------------------*/
double max(double a,double b)
 {
  return ((a>b) ? a : b);
 }
/*---------------------------------*/
double min(double a,double b)
 {
  return ((a<b) ? a : b);
 }
/*---------------------------------*/
double ycalc(double x,double y,double *a,double T)
 {
  double dy,term,foh1,foh2,ym,yl,dyold,dfdy;
  int i;

  for(i=0;i<3;i++){
    dyold=y;
    do{
      foh1=ZF(x,y,a[0],a[1],a[2],T);
      dfdy=DFDY(x,y,a[0],a[2],T);
      dy=foh1/dfdy;
      if (((fabs(y)-fabs(dy)) > 0.0)  && (fabs(dy) < (0.75*fabs(dyold)))){
	y-=dy;
	dyold=dy;
       }
      else{
	if(foh1 < (foh2=ZF(x,(ym=1.5*y),a[0],a[1],a[2],T)))  {/* fo is increasing function */
	  yl=y;
	  while (foh1 >= 0) foh1=ZF(x,(yl/=1.1),a[0],a[1],a[2],T);
	  while (foh2 <= 0) foh2=ZF(x,(ym*=1.1),a[0],a[1],a[2],T);
	 }
	else{				/* fo is decreasing function */
	  yl=ym;ym=y;
	  while (foh1 >= 0) foh1=ZF(x,(yl*=1.1),a[0],a[1],a[2],T);
	  while (foh2 <= 0) foh2=ZF(x,(ym/=1.1),a[0],a[1],a[2],T);
	 }
       do{
	  if (ZF(x,(y=0.5*(ym+yl)),a[0],a[1],a[2],T) < 0)
	   yl=y;
	  else ym=y;
	}while (fabs((dy=(yl-ym))/yl)>1e-6);
       }
     }while (fabs(dy)/fabs(y)>1e-6);
   }
 return y;
 }
/*---------------------------------*/
void swap(a,b)
 double *a,*b;
 {
  double temp;

  temp=*a;
  *a=*b;
  *b=temp;
 return;
 }
